// Logo for PNML view by Freek van Walderveen

global_settings {
  assumed_gamma 2.2
//  max_trace_level 5
}

#include "shapes.inc"
#include "colors.inc"
#include "textures.inc"
#include "glass.inc"
#include "metals.inc"

#declare ARROW_WIDTH  = 5.0;
#declare ARROW_LENGTH = 8.0;
#declare OBJECT_HEIGHT = 6.0;

#declare Floor =
plane { y, -200.0
      hollow on
    finish {
//      crand 0.05
//      ambient 0.3
//      diffuse 0.7
    }
   pigment { rgb <1, 1, 1> }
};


#declare Transition =
union {
  difference {
    box { <-7.5, -OBJECT_HEIGHT+.5, -7.5>, <7.5, OBJECT_HEIGHT-.5, 7.5> }
    box { <-7.0, -OBJECT_HEIGHT-.5, -7.0>, <7.0, OBJECT_HEIGHT+.5, 7.0> }
    //interior { I_Glass }
    texture { Glass }
    finish { F_Glass8 }
  }
  
  box { <-6.8, -OBJECT_HEIGHT, -6.8>, <6.8, OBJECT_HEIGHT, 6.8>
    pigment { color rgbf <0.6, 0.8, 0.0, 0.9> }
    finish { F_Glass3 }
  }
};

#declare Place =
union {
  difference {
    cylinder { <0.0, -OBJECT_HEIGHT+.5, 0.0>, <0.0, OBJECT_HEIGHT-.5, 0.0>, 7.5 }
    cylinder { <0.0, -OBJECT_HEIGHT-.5, 0.0>, <0.0, OBJECT_HEIGHT+.5, 0.0>, 7.0 }
    texture { Glass }
  }
  
  cylinder { <0.0, -OBJECT_HEIGHT, 0.0>, <0.0, OBJECT_HEIGHT, 0.0>, 6.8
    pigment { color rgbf <1.0, 1.0, 0.0, 0.8> }
    finish { F_Glass4 }
  }
};

#declare Token = 
sphere { <0.0, 0.0, 0.0>, 2.5
  
  pigment { P_Chrome2 }
  finish { F_MetalB }
}


camera {
   location <2.0, 80.0, -20.0>
   up <0.0, 1.0, 0.0>
   right <4/3, 0.0, 0.0>
   look_at <0.0, 0.0, 0.0>
}

light_source { <50.0, 80.0, -80.0> colour rgb <2,2,2> }

object { Floor }
object { Transition translate <0.0, 0.0, -20.0> }
object { Place translate <20.0, 0.0,  0.0> }
/*
object { Token translate <17.0, 4.0,  0.0> }
object { Token translate <21.5, 4.0, -2.6> }
object { Token translate <21.5, 4.0,  2.6> }
*/
// Arc from transition to place
union {
  cylinder { <0.0, 0.0, -12.5>, <0.0, 0.0, 0.0>, 1.5 }
  cylinder { <0.0, 0.0, 0.0>, <12.5-ARROW_LENGTH, 0.0, 0.0>, 1.5 }
  sphere   { <0.0, 0.0, 0.0>, 1.5 }
  cone     { <12.5-ARROW_LENGTH, 0.0, 0.0>, ARROW_WIDTH, <12.5, 0.0, 0.0>, 0.0 }
  
  finish { F_MetalA }
  pigment { P_Chrome1 }
}

// Arc from place to transition
union {
  cylinder { <20.0, 0.0, -7.5>, <20.0, 0.0, -20.0>, 1.5 }
  cylinder { <20.0, 0.0, -20.0>, <7.5+ARROW_LENGTH, 0.0, -20.0>, 1.5 }
  sphere   { <20.0, 0.0, -20.0>, 1.5 }
  cone     { <7.5+ARROW_LENGTH, 0.0, -20.0>, ARROW_WIDTH, <7.5, 0.0, -20.0>, 0.0 }
  
  finish { F_MetalA }
  pigment { P_Chrome1 }
}


