/*
 * FILE:    labelplacer.h
 * PACKAGE: PNML view
 * LICENCE: See LICENCE file
 * AUTHOR:  Freek van Walderveen
 *
 */

#ifndef LABELPLACER_H
#define LABELPLACER_H

#include <QString>
#include <QPainter>
#include <QVector>

class QPainter;
class QRect;
class QPoint;
class DrawProps;

class LabelPlacer {
public:
  LabelPlacer();
  virtual ~LabelPlacer();
  
  void draw(QPainter *p, DrawProps *drawProps); // Pre: p.isActive() && drawProps
    
  QRect getBoundingRect(DrawProps *drawProps, QPainter *painter = NULL); // Pre: drawProps && (painter ? painter.isActive() : true)
  void addLabel(QPoint pos, QString test);
  void addRoleLabel(QPoint pos, QString test);
  void addLine(QLine line);
  void addRect(QRect rect);
  void clearAll();
  
  inline void setChanged();
  
protected:
  virtual void place(DrawProps *drawProps, QPainter *painter = NULL); // Pre: drawProps && (painter ? painter.isActive() : true)
  bool isObstructed(QRect rect);
  QRect findRect(QRect rect);
  QLine findLine(QRect rect);
  
  QVector<QPair<QPoint, QString> > labels;
  QVector<QPair<QRect, QString> > placedLabels;
  QVector<QPair<QPoint, QString> > roleLabels;
  QVector<QPair<QRect, QString> > placedRoleLabels;
  QVector<QLine> lines;
  QVector<QRect> rects;

  bool hasChanged;
   
private:
};

inline void LabelPlacer::setChanged() {
  hasChanged = true;
}

#endif //LABELPLACER_H
