/*
 * FILE:    main.cpp
 * PACKAGE: PNML view
 * LICENCE: See LICENCE file
 * AUTHOR:  Freek van Walderveen
 *
 */

#include <QApplication>
#include <QMessageBox>
#include "mainwindow.h"
#include <stdexcept>

int askUser(QString message) {
  message += "\n\nPlease contact the author about this problem.";
  QMessageBox::critical(NULL,
                        "PNML view critical problem",
                        message);
  return 1;
}

int main(int argc, char *argv[]) {
  QApplication app(argc, argv);

  // Application name for saving settings
  QCoreApplication::setOrganizationName("vanwal");
  QCoreApplication::setOrganizationDomain("vanwal.nl");
  QCoreApplication::setApplicationName("pnmlview");
  
  try {
    MainWindow window;
    window.show();
    if (argc == 2) {
      window.openFile(argv[1]);
    }

    return app.exec();
    
  } catch (std::bad_alloc e) {
    return askUser(QString("Failed to allocate storage (%1)").arg(e.what()));
  } catch (std::exception e) {
    return askUser(QString("Caught unhandled std::exception: ``%1''").arg(e.what()));
  } catch (...) {
    return askUser("Caught unhandled exception.");
  }
}

