/*
 * FILE:    prefdialog.h
 * PACKAGE: PNML view
 * LICENCE: See LICENCE file
 * AUTHOR:  Freek van Walderveen
 *
 */

#ifndef PREFDIALOG_H
#define PREFDIALOG_H

#include "drawprops.h"
#include ".ui/ui_prefdialog.h"

#include <QDialog>

class PrefDialog : public QDialog {
  Q_OBJECT

public:
  PrefDialog(DrawProps *dp, QWidget * parent = 0, Qt::WFlags flags = 0); // Pre: dp
  virtual ~PrefDialog();

signals:
  void applied();
    
protected:
  void loadPrefs();
  void savePrefs();

private slots:
  void on_okButton_clicked();
  void on_applyButton_clicked();
  void on_cancelButton_clicked();
  void on_colorListWidget_currentItemChanged(QListWidgetItem *item, QListWidgetItem *previous);
  void on_fontListWidget_currentRowChanged(int row);
  void on_changeFontButton_clicked();
  void on_pimpButton_clicked();
  void on_resetButton_clicked();
  
  void prefChanged();

private:
  Ui::PrefDialog ui;
  DrawProps *drawProps;

};

#endif //~PREFDIALOG_H
